"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const esotope_hammerhead_1 = require("esotope-hammerhead");
const TEMP_VARIABLE_PREFIX = '_hh$temp';
class TempVariables {
    constructor() {
        this._list = [];
    }
    static resetCounter() {
        TempVariables._counter = 0;
    }
    static generateName(baseName, key, index) {
        if (!baseName)
            return TEMP_VARIABLE_PREFIX + TempVariables._counter++;
        if (key) {
            if (key.type === esotope_hammerhead_1.Syntax.Identifier)
                return baseName + '$' + key.name;
            if (key.type === esotope_hammerhead_1.Syntax.Literal && key.value)
                return baseName + '$' + key.value.toString().replace(/[^a-zA-Z0-9]/g, '');
        }
        return baseName + '$i' + index;
    }
    static isHHTempVariable(name) {
        return name.indexOf(TEMP_VARIABLE_PREFIX) === 0;
    }
    append(name) {
        this._list.push(name);
    }
    get() {
        return this._list;
    }
}
exports.default = TempVariables;
TempVariables._counter = 0;module.exports = exports.default;

