"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const STRINGIFIED_FUNCTION_OPTIONS = '{ <predicate> }';
function stringifyObjectOptions(rule) {
    const ruleOptions = rule.options;
    const stringifiedOptions = [
        { name: 'url', value: ruleOptions.url },
        { name: 'method', value: ruleOptions.method },
        { name: 'isAjax', value: ruleOptions.isAjax },
    ];
    const msg = stringifiedOptions.filter(option => !!option.value)
        .map(option => {
        const stringifiedOptionValue = (0, lodash_1.isString)(option.value) ? `"${option.value}"` : option.value;
        return `${option.name}: ${stringifiedOptionValue}`;
    })
        .join(', ');
    return `{ ${msg} }`;
}
function default_1(rule) {
    return (0, lodash_1.isFunction)(rule.options) ? STRINGIFIED_FUNCTION_OPTIONS : stringifyObjectOptions(rule);
}
exports.default = default_1;module.exports = exports.default;

